<template>
	<f7-page name="financialreportdetail" @page:beforein="onPageBeforeIn" @page:beforeout="onPageBeforeOut">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large title-large="Tanda Terima">
			<f7-nav-left back-link>
            </f7-nav-left>
            <f7-nav-title class="show-small-title">Kas</f7-nav-title>
            <f7-nav-right>
                <f7-link href="/financial-reports/create/" icon-f7="add" color="smoothgray" icon-only></f7-link>
            </f7-nav-right>
		</f7-navbar>

		<!-- Page content-->
        <f7-block class="text-align-center">
            <div id="receipt" class="text-align-center" v-if="financialreport && financialreport.residential">
                <img :src="require('../assets/logo-text-only.png')" width="100">
                <h3 class="no-margin-bottom">{{ financialreport.residential.name }}</h3>
                <small>{{ financialreport.residential.address }}, {{ financialreport.residential.administrative_region.join(', ') }}</small>
                <h2>Tanda Terima</h2>
                <f7-row class="receipt-item text-align-left">
                    <f7-col width="60">
                        <span>{{ financialreport.title }}</span>
                    </f7-col>
                    <f7-col width="40">
                        <strong class="text-align-right display-block">Rp {{ financialreport.trx_type == 'credit' ? financialreport.credit.format(2,0,'.',',') : financialreport.debit.format(2,0,'.',',') }}</strong>
                    </f7-col>
                </f7-row>
                <f7-row class="receipt-item text-align-left">
                    <f7-col width="60">
                        <strong>Total</strong>
                    </f7-col>
                    <f7-col width="40">
                        <strong class="text-align-right display-block">Rp {{ financialreport.trx_type == 'credit' ? financialreport.credit.format(2,0,'.',',') : financialreport.debit.format(2,0,'.',',') }}</strong>
                    </f7-col>
                </f7-row>
                <br>
                <span class="display-block text-align-left" v-if="financialreport.note">Catatan:</span>
                <span class="display-block text-align-left" v-if="financialreport.note">{{ financialreport.note }}</span>
                <br>
                <br>
                <strong class="text-align-left display-block no-margin">{{ financialreport.residential.administrative_region[2].replace(/(Kota|Kab)/g, '')+', '+dateFormat(financialreport.updated, 'DD MMMM YYYY') }}</strong>
                <f7-row class="payer text-align-left">
                    <f7-col>
                        <span class="display-block">Diterima Dari:</span>
                        <strong class="display-block">{{ financialreport.author.profile.fullname }}</strong>
                    </f7-col>
                    <f7-col>
                        <span class="display-block">Penerima:</span>
                        <strong class="display-block">{{ financialreport.recepient }}</strong>
                    </f7-col>
                </f7-row>
                <br>
                <br>
                <small class="text-align-left display-block no-margin">Tanda terima ini merupakan bukti pembayaran yang sah antar kedua belah pihak.</small>
            </div>
            <!-- <br>
            <br>
            <f7-button v-if="financialreport && financialreport.residential" @click="downloadReceipt" fill-ios round-ios color="white" icon-f7="cloud_download" class="button-auto gradient-button text-align-left" large> Download Tanda Terima</f7-button> -->
        </f7-block>
    </f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import moment from 'moment';
import html2pdf from 'html2pdf.js';
import { dateFormat } from '../js/utils';
export default {
    name: 'FinancialReportDetail',
    data(){
        return {
        }
    },
    computed: {
        ...mapGetters('auth', ['user']),
        ...mapGetters('financialreport', [
            'financialreport'
        ])
    },    
    methods: {
        dateFormat,
        onPageBeforeIn(){
            const self = this;
            const app = self.$f7;

            app.preloader.show('green');

            self.$store.dispatch('financialreport/viewFinancialReport', {
                id: self.$f7route.params.id,
                only: 'id,number,title,note,recepient,trx_type,status,credit,debit,period,balance,created,updated,category.id,category.name,medias.mimetype,medias.url,medias.filename,medias.original_filename,signs,residential.name,residential.address,residential.administrative_region,author.id,author.profile.fullname,author.profile.initial,author.profile.media'
            }).then(() => {
                app.preloader.hide();
            });
            
        },
        onPageBeforeOut(){
            const self = this;
            const app = self.$f7;

            self.$store.dispatch('financialreport/resetFinancialReport');
        },
        downloadReceipt(){
            moment.locale('id');

            const self = this;

            self.$f7.preloader.show('green');

            let html = self.$$('#receipt')[0];

            let opt = {
                margin: 10,
                filename: 'Tanda Terima.pdf',
                image: {type: 'jpeg', quality: 0.98},
                pagebreak: {mode: ['avoid-all', 'css', 'legacy']},
                html2canvas: {scale: 2},
                jsPDF: {unit: 'mm', 'format': 'c6', orientation: 'portrait'}
            };
            html2pdf().set(opt).from(html).save().then(function(){
                self.$f7.preloader.hide();
            });
        }
    }
}
</script>